-- This version does not use the gps module because it sometimes fails on servers when no one is online



basic = require("lib.basic")
tutel = require("lib.tutel")
networking = require("lib.networking")

oreList = {
  [0] = "minecraft:gold_ore",
  [1] = "minecraft:deepslate_gold_ore",
  [2] = "minecraft:iron_ore",
  [3] = "minecraft:deepslate_iron_ore",
  [4] = "minecraft:coal_ore",
  [5] = "minecraft:deepslate_coal_ore",
  [6] = "minecraft:lapis_ore",
  [7] = "minecraft:deepslate_lapis_ore",
  [8] = "minecraft:diamond_ore",
  [9] = "minecraft:deepslate_diamond_ore",
  [10] = "minecraft:redstone_ore",
  [11] = "minecraft:deepslate_redstone_ore",
  [12] = "minecraft:emerald_ore",
  [13] = "minecraft:deepslate_emerald_ore",
  [14] = "minecraft:nether_quartz_ore",
  [15] = "minecraft:nether_gold_ore",
  [16] = "minecraft:copper_ore",
  [17] = "minecraft:deepslate_copper_ore",
  [18] = "minecraft:ancient_debris",
}

keepList = {
  [0] = "computercraft:wireless_modem_advanced",
  [1] = "minecraft:chest",
  [2] = "minecraft:barrel",
  [3] = "minecraft:raw_gold",
  [4] = "minecraft:raw_iron",
  [5] = "minecraft:coal",
  [6] = "minecraft:lapis_lazuli",
  [7] = "minecraft:diamond",
  [8] = "minecraft:redstone",
  [9] = "minecraft:emerald",
  [10] = "minecraft:quartz",
  [11] = "minecraft:gold_nugget",
  [12] = "minecraft:ancient_debris",
  [13] = "minecraft:raw_copper",
}





local function setState()
  basic.writeToFile("brulijam/files/state-t-fiboMiner.txt", textutils.serialize(state))
  sleep(0.1)
end

local function getState()
  if not fs.exists "brulijam/files/state-t-fiboMiner.txt" then
    state = {}
    state["dataCurrentFibo"] = 2
    state["dataGoalRows"] = 0
    state["dataGoalPathProgress"] = 0
    state["dataCurrentRow"] = 0
    state["dataCurrentPathProgress"] = 0
    state["lastValidR"] = 0
    state["lastValidX"] = 0
    state["lastValidY"] = 0
    state["lastValidZ"] = 0

    basic.writeToFile("brulijam/files/state-t-fiboMiner.txt", textutils.serialize(state))
  else
    state = basic.readFileAll("brulijam/files/state-t-fiboMiner.txt")
    state = textutils.unserialize(state)
  end
  return state
end


local function savePos(prefix)
  --save position to file and ntfy
  local pos = tutel.getPos()

  basic.appendToFileNl("/brulijam/files/chests-turtle-miner-fibo.txt", prefix .. pos["x"] .. ", " .. pos["y"]+1 .. ", " .. pos["z"])
  basic.ntfy("(Mining) " .. prefix .. pos["x"] .. ", " .. pos["y"]+1 .. ", " .. pos["z"])
end

local function inventoryRework()
  chestAvailable = false
  chestSlot = 0
  spaceAvailable = false

  for i=1, 16 do
    turtle.select(i)
    itemDetail = turtle.getItemDetail()
    if itemDetail ~= nil then
      if itemDetail.name == "minecraft:coal" or itemDetail.name == "minecraft:charcoal" then
        turtle.refuel()
        spaceAvailable = true
      elseif itemDetail.name == "minecraft:chest" or itemDetail.name == "minecraft:barrel" then
        chestAvailable = true
        chestSlot = i
      else --check if item can be thrown away
        keepItem = false
        for j=0, #keepList do
          if itemDetail.name == keepList[j] then
            keepItem = true
          end
        end
        if not keepItem then
          turtle.dropDown()
          spaceAvailable = true
        end
      end
    else --at least one slot of space remaining
      spaceAvailable = true
    end
  end

  --store items away
  if not spaceAvailable and chestAvailable then
    --turtle.up()
    tutel.up()
    basic.secureDigUp()
    --turtle.up()
    tutel.up()
    basic.secureDigUp()
    turtle.select(chestSlot)
    turtle.placeUp()
    savePos("Chest placed at ")

    for k=1, 16 do
      turtle.select(k)
      itemDetail = turtle.getItemDetail()
      if itemDetail ~= nil then
        if itemDetail.name ~= "minecraft:chest" and itemDetail.name ~= "minecraft:barrel" and itemDetail.name ~= "computercraft:wireless_modem_advanced" then
          turtle.dropUp()
        end
      end
    end
    --turtle.down()
    tutel.down()
    --turtle.down()
    tutel.down()
  end

  if not spaceAvailable and not chestAvailable then
    --savePos("Turtle stopped")
    local pos = tutel.getPos()
    basic.ntfy("(Mining) " .. "Turtle stopped mining at " .. pos["x"] .. ", " .. pos["y"] .. ", " .. pos["z"])
    shell.run("delete /brulijam/task.lua")
    shell.run("reboot")
  end
end


local function isOre(blockData)
  for i=0, #oreList do
    if blockData["name"] == oreList[i] then
      inventoryRework()
      return true
    end
  end
  return false
end

local function recursiveOreMining()
  for i=0, 3 do
    --turtle.turnLeft()
    tutel.left()
    blockFound, blockData = turtle.inspect()
    if isOre(blockData) then
      tutel.secureDig()
      --turtle.forward()
      tutel.forward()
      recursiveOreMining()
      --turtle.back()
      tutel.back()
    end
  end

  blockFound, blockData = turtle.inspectUp()
  if isOre(blockData) then
    tutel.secureDigUp()
    --turtle.up()
    tutel.up()
    recursiveOreMining()
    --turtle.down()
    tutel.down()
  end

  blockFound, blockData = turtle.inspectDown()
  if isOre(blockData) then
    tutel.secureDigDown()
    --turtle.down()
    tutel.down()
    recursiveOreMining()
    --turtle.up()
    tutel.up()
  end
end

local function mineRow()
  --mine a 3 Block high Tunnel for <distance> Blocks
  for i=state["dataCurrentPathProgress"], state["dataGoalPathProgress"]-2 do
    print("row: " .. state["dataCurrentRow"]+1 .. "/" .. state["dataGoalRows"] .. ", pathProgress: " .. state["dataCurrentPathProgress"]+1 .. "/" .. state["dataGoalPathProgress"])

    -- check fuel level
    if turtle.getFuelLevel() == 0 then
      local pos = tutel.getPos()
      basic.ntfy("(Mining) " .. "Turtle has no fuel at " .. pos["x"] .. ", " .. pos["y"] .. ", " .. pos["z"])
      shell.run("delete /brulijam/task.lua")
      shell.run("reboot")
    end
    
    tutel.secureDig()
    --turtle.forward()
    tutel.forward()
    tutel.secureDigUp()
    tutel.secureDigDown()

    --clearInventory()
    --inventoryRework()

    --check current mining step for ore
    --turtle.up()
    tutel.secureDigUp()
    tutel.up()
    recursiveOreMining()
    --turtle.down()
    tutel.secureDigDown()
    tutel.down()
    recursiveOreMining()
    --turtle.down()
    tutel.secureDigDown()
    tutel.down()
    recursiveOreMining()
    --turtle.up()
    tutel.secureDigUp()
    tutel.up()
    
    --inventoryRework() --only needed when ore found
    --clearInventory()
    --checkInventory()ußgelder zwischen 10 und 80
    
    --save path progress
    state["dataCurrentPathProgress"] = i+1

    local pos = tutel.getPos()
    --TODO SAVE LAST VALID POSITION HERE
    state["lastValidR"] = pos["r"]
    state["lastValidX"] = pos["x"]
    state["lastValidY"] = pos["y"]
    state["lastValidZ"] = pos["z"]
    setState()
  end
  print("row: " .. state["dataCurrentRow"]+1 .. "/" .. state["dataGoalRows"] .. ", pathProgress: " .. state["dataCurrentPathProgress"]+1 .. "/" .. state["dataGoalPathProgress"])
end

local function mineChunk()
  state = getState()

  state["dataGoalRows"] = state["dataCurrentFibo"]
  state["dataGoalPathProgress"] = 3*(state["dataCurrentFibo"]-1)+1
  setState(state)

  for i=state["dataCurrentRow"], state["dataGoalRows"]-1 do
    sleep(0.5)
    mineRow(state["dataGoalPathProgress"])
    
    --turn back and return to start of row if not last row
    if i<state["dataGoalRows"]-1 then
      --turtle.turnLeft()
      tutel.left()
      --turtle.turnLeft()
      tutel.left()

      for j=1, state["dataGoalPathProgress"]-1 do
        --turtle.forward()
        tutel.forward()
      end

      --go to next row
      --turtle.turnLeft()
      tutel.left()
      for j=0, 2 do
        tutel.secureDig()
        --turtle.forward()
        tutel.forward()
        tutel.secureDigUp()
        tutel.secureDigDown()
      end
      --turtle.turnLeft()
      tutel.left()
    end
    
    state["dataCurrentRow"] = i+1
    state["dataCurrentPathProgress"] = 0
    setState()
  end

  --reset row progress
  state["dataCurrentRow"] = 0
  setState()
end

local function mineFibo()

  basic.ntfy("Started Mining")
  state = getState()

  while true do
    mineChunk()
    print("go to next chunk")

    --go to next chunk
    --turtle.turnRight()
    tutel.right()
    for j=1, 2 do
      tutel.secureDig()
      --turtle.forward()
      tutel.forward()
      tutel.secureDigUp()
      tutel.secureDigDown()
    end

    --get next fibo number
    state["dataCurrentFibo"] = math.floor((state["dataCurrentFibo"] * (1+math.sqrt(5))/2) + 0.5)
    setState()
  end
end

local function checkPosition()
  pos = tutel.getPos()
  state = getState()

  print("pos:" .. textutils.serialize(pos))

  if not (pos["r"] == state["lastValidR"] and pos["x"] == state["lastValidX"] and pos["y"] == state["lastValidY"] and pos["z"] == state["lastValidZ"]) then
    --TODO go to last valid pos
    print("Tutel moving to where it should be")
    tutel.goToPosition(state["lastValidR"], state["lastValidX"], state["lastValidY"], state["lastValidZ"])

  end
end

-- in case the tutel needs to refuel before heading off
inventoryRework()

if fs.exists "brulijam/files/state-t-fiboMiner.txt" then
  --setup()
  checkPosition()
  mineFibo()
else
  state = getState()

  local pos = tutel.getPos()

  state["lastValidR"] = pos["r"]
  state["lastValidX"] = pos["x"]
  state["lastValidY"] = pos["y"]
  state["lastValidZ"] = pos["z"]

  setState(state)

  mineFibo()
end
  